# Sulk - missions - MISH_beta_1

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
This module contains constants and functions for a Sulk mission.
"""

from constants.mission_locals import *

####### Strings
NAME = "Messenger"

NUM = 1

FAMILY = "Beta Campaign"

AUTHOR = "Toby Woodwark"

INFO =	"To win, at least one Space Marine must escape through an exit point.  \
The Genestealers must prevent this."

STORY = "The squad was completing a sweep of the sector for alien lifeforms,\
with nothing to report so far..." 


####### Board array
BOARD = (	

( #1room
(( 0, 9 ), {M:None}),	(( 1, 9 ), {M:None}),	(( 2, 9 ), {M:None}),
(( 0, 10), {M:None}),	(( 1, 10), {M:None}),	(( 2, 10), {M:None}),	(( 3, 10), {M:None,DOOR:RIGHT}),
(( 0, 11), {M:None}),	(( 1, 11), {M:None}),	(( 2, 11), {M:None}),
),

( #2
(( 4, 10), ),	(( 5, 10), )
),

( #X
		(( 7,  9), ),
(( 6, 10), ),	(( 7, 10), ),	(( 8, 10), ),
		(( 7, 11), ),
),

( #3
(( 7,  6),{DOOR:UP}),	
(( 7,  7),),	
(( 7,  8),),
),

( #T
(( 7,  3),),
(( 7,  4),),	(( 8,  4),),	
(( 7,  5),),	
),

( #5
(( 9, 4),),	((10, 4),), ((11,  4),), ((12,  4),), ((13,  4),),
),

( #T
			    (( 7,  0),{ENTRY:UP}),
(( 6,  1), {ENTRY:LEFT}),   (( 7,  1),),	
			    (( 7,  2),),	
),

( #3room
				((10,  9),),	((11,  9),),	((12,  9),),
(( 9, 10), {DOOR:RIGHT}),	((10, 10),),	((11, 10),),	((12, 10),),	((13, 10), {DOOR:RIGHT}), 
				((10, 11),),	((11, 11),),	((12, 11),),
						((11, 12),{DOOR:UP}),
),

( #T
		((15,  9), ),
((14, 10), ),	((15, 10), ),	((16, 10), ),
),

( #corner
((17, 10),),	((18, 10),),
    		((18, 11),)
),

( #3
(( 7, 12),),	
(( 7, 13),),	
(( 7, 14),),
),

( #2room
	       (( 7, 15),{DOOR:UP}),
(( 6, 16),),	(( 7, 16),),	    (( 8, 16),),
(( 6, 17),),	(( 7, 17),),	    (( 8, 17),),	(( 9, 17),{DOOR:RIGHT}),
(( 6, 18),),	(( 7, 18),),	    (( 8, 18),),
),

( #T
		((11, 16),),
((10, 17),),	((11, 17),),
		((11, 18),),
),

( #corner
((11, 19),),
((11, 20),),	((12, 20),),
),

( #5
((13, 20),),	((14, 20),),	((15, 20),{DOOR:RIGHT}),((16, 20),),	((17, 20),),
),

( #3
((18, 20),),	((19, 20),),	((20, 20),),
),

( #T
((11, 13),),
((11, 14),),	((12, 14),),
((11, 15),{DOOR:UP}),
),

( #3
((13, 14),),	((14, 14),),	((15, 14),),
),

( #3room
						((18, 12),{DOOR:UP}),
				((17, 13),),	((18, 13),),	((19, 13),),
((16, 14),{DOOR:RIGHT}),	((17, 14),),	((18, 14),),	((19, 14),),	((20, 14),{DOOR:RIGHT}),
				((17, 15),),	((18, 15),),	((19, 15),),
),

( #X
		((22, 13),),
((21, 14),),	((22, 14),),	((23, 14),),
		((22, 15),),
),

( #X
		((25, 13),),
((24, 14),),	((25, 14),),	((26, 14),),
		((25, 15),),
),

( #3
((22, 16),),
((22, 17),),
((22, 18),),
),

( #3
((25, 16),),
((25, 17),),
((25, 18),),
),

( #3
((22, 10),),
((22, 11),{DOOR:UP}),
((22, 12),),
),

( #3
((25, 10),),
((25, 11),{DOOR:UP}),
((25, 12),),
),

( #T
		((22, 19),{DOOR:UP}),
((21, 20),),	((22, 20),),	((23, 20),),
),

( #T
		((25, 19),),
((24, 20),),	((25, 20),),
		((25, 21),),
),

( #corner
((25, 22),{DOOR:UP}),
((25, 23),),	((26, 23),{ENTRY:RIGHT}),
),

( #2room
						((29, 12),{DOOR:UP}),
				((28, 13),),	((29, 13),),	((30, 13),),
((27, 14),{DOOR:RIGHT}),	((28, 14),),	((29, 14),),	((30, 14),),
				((28, 15),),	((29, 15),),	((30, 15),),
),

( #2
((29, 10),),
((29, 11),),
),

( #T
((28, 8),),	((29,  8),),	((30,  8),),
		((29,  9),),
),

( #3
((31, 8),),	((32,  8),),	((33,  8),{EXIT:RIGHT}),
),

( #1
((27, 8),{DOOR:RIGHT}),
),

( #X
		((22,  7),),
((21,  8),),	((22,  8),),	((23,  8),),
		((22,  9),),
),

( #T
((24,  8),),	((25,  8),),	((26,  8),),
		((25,  9),),
),

( #5
((22,  2),),
((22,  3),),
((22,  4),),
((22,  5),),
((22,  6),),
),

( #corner
((22,  0),),	((23,  0),{ENTRY:RIGHT}),
((22,  1),),
),

( #corner
((19,  7),),
((19,  8),),	((20,  8),),
),

( #2room
			((18,  3),),    ((19,  3),),	((20,  3),),
((17,  4),{DOOR:RIGHT}),((18,  4),),    ((19,  4),),	((20,  4),),
			((18,  5),),    ((19,  5),),	((20,  5),),
					((19,  6),{DOOR:UP}),
),

( #T
((14,  4),),((15,  4),),	((16,  4),),
			((15,  5),),
),

( #3
((15,  6),),
((15,  7),),
((15,  8),),
),


)


####### Constants
FLAGS = ()

MARINES =   (
		(
		"Lawer", 
		((TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_SERGEANT,MARINETEAM), (TERMINATOR_MARINE_WITH_HEAVY_FLAMER,MARINETEAM)),
		),
	    )

BLIPS = (2, 1)

BLIP_SET = BLIP_SET_BASIC


####### Functions
def pre_deploy_rule(aclass, square, squadname=None):
    #no special rules here.
    return 1


def post_deploy_script(piece):
    return
    

def post_action_script(piece, actiontype):
    return

    
def maction_end_script(sulkgame):
    return ""


def end_script(sulkgame):
    return ""


def victory_check(sulkgame):
    #In this mission, no draw is possible
    
    if sulkgame.marines:
	for m in sulkgame.marines.sprites():
	    if m.get_lurking():
		return sulkgame.marines
    else:
	return sulkgame.stealers
