# Sulk - missions - MISH_beta_2

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
This module contains constants and functions for a Sulk mission.
"""

from constants.mission_locals import *

####### Strings
NAME = "Download"

NUM = 2

FAMILY = "Beta Campaign"

AUTHOR = "Toby Woodwark"

INFO =	"To win, a Sergeant must occupy the central square in the Data Room for 4 consecutive end phases.\
  If he moves away from that spot, or dies, the counter will reset.\
  However, he may turn and fight normally.\
  The Genestealers must prevent this by killing both Sergeants."

STORY = "NO STORY YET." 


####### Board array
BOARD = (	

( #5
(( 7,  1),{M:None}),	
(( 7,  2),{M:None}),	
(( 7,  3),{M:None}),
(( 7,  4),{M:None}),	
(( 7,  5),{M:None}),
),

( #5
((12,  1),{M:None}),	
((12,  2),{M:None}),	
((12,  3),{M:None}),
((12,  4),{M:None}),	
((12,  5),{M:None}),
),

( #3
((18,  3),{ENTRY:UP}),	
((18,  4),),	
((18,  5),),
),

( #2
(( 1, 10),{ENTRY:LEFT}),	(( 2, 10), )
),

( #corner
    		(( 4,  9),),
(( 3, 10),),	(( 4, 10),),
),

( #corner
(( 4,  7),),    (( 5,  7),),
(( 4,  8),),
),

( #X
		(( 7,  6), ),
(( 6,  7), ),	(( 7,  7), ),	(( 8,  7), ),
		(( 7,  8), ),
),

( #2
(( 9,  7), ),	((10,  7),{DOOR:RIGHT}),
),

( #T
		((12,  6), ),
((11,  7), ),	((12,  7), ),	((13,  7), ),
),

( #T
((14,  7), ),	((15,  7), ),	((16,  7),{DOOR:RIGHT}),
		((15,  8), ),
),

( #T
		(( 18,  6), ),
((17,  7), ),	(( 18,  7), ),
		(( 18,  8), ),
),

( #2
(( 7,  9), ),
(( 7, 10), ),
),

( #3
((15,  9),),	
((15, 10),),	
((15, 11),),
),

( #3
((18,  9),),	
((18, 10),{DOOR:UP}),	
((18, 11),),
),

( #3room
		(( 7, 11),{DOOR:UP}),
(( 6, 12),),	(( 7, 12),),	(( 8, 12),),
(( 6, 13),),	(( 7, 13),),	(( 8, 13),),	(( 9, 13),{DOOR:RIGHT}),
(( 6, 14),),	(( 7, 14),),	(( 8, 14),),
                (( 7, 15),{DOOR:UP}),
),

( #1
((10, 13),),
),

( #T
((11, 13), ),	((12, 13), ),	((13, 13),),
		((12, 14), ),
),

( #T
		((15, 12), ),
((14, 13), ),	((15, 13), ),	((16, 13), ),
),

( #T
		((18, 12), ),
((17, 13), ),	((18, 13), ),	((19, 13), ),
),

( #T
                ((21, 12),{ENTRY:UP}),
((20, 13), ),	((21, 13), ),	((22, 13),{ENTRY:RIGHT}),
),

( #2
(( 7, 16), ),
(( 7, 17), ),
),

( #4
((12, 15), ),
((12, 16), ),
((12, 17), ),
((12, 18), ),
),

( #T
                        (( 7, 18), ),
(( 6, 19),{ENTRY:LEFT}),(( 7, 19), ),
                        (( 7, 20), ),
),

( #big4room
                                                        ((12, 19),{DOOR:UP}),
                        ((10, 20),),     ((11, 20),),   ((12, 20),), ((13, 20),), ((14, 20),),
                        ((10, 21),),     ((11, 21),),   ((12, 21),), ((13, 21),), ((14, 21),),
(( 9, 22),{DOOR:RIGHT}), ((10, 22),),     ((11, 22),),   ((12, 22),{O:1,COMMENT:"Data Room"}), ((13, 22),), ((14, 22),),  ((15, 22),{DOOR:RIGHT}), 
                        ((10, 23),),     ((11, 23),),   ((12, 23),), ((13, 23),), ((14, 23),),
                        ((10, 24),),     ((11, 24),),   ((12, 24),), ((13, 24),), ((14, 24),),
                                                        ((12, 25),{DOOR:UP}),

),

( #3room
                                        ((12, 26),{DOOR:UP}),
                        ((11, 27),),	((12, 27),),	((13, 27),),
((10, 28),{DOOR:RIGHT}), ((11, 28),),	((12, 28),),	((13, 28),),	((14, 28),{DOOR:RIGHT}),
                        ((11, 29),),	((12, 29),),	((13, 29),),
),

( #1
(( 9, 28),),
),

( #corner
(( 7, 27),),
(( 7, 28),), (( 8, 28),),
),

( #3
(( 7, 24),),
(( 7, 25),{DOOR:UP}),
(( 7, 26),),
),

( #X
		(( 7,  21), ),
(( 6, 22), ),	(( 7,  22), ),	(( 8, 22), ),
		(( 7,  23), ),
),

( #3
(( 3, 22),{ENTRY:LEFT}), (( 4,  22), ),	(( 5, 22), ),
),

( #1
((16, 22),),
),

( #3room
                                        ((19, 20),{DOOR:UP}),
                        ((18, 21),),	((19, 21),),	((20, 21),),
((17, 22),{DOOR:RIGHT}), ((18, 22),),	((19, 22),),	((20, 22),),
                        ((18, 23),),	((19, 23),),	((20, 23),),
                                        ((19, 24),{DOOR:UP}),
),

( #corner
((19, 18),),    ((20, 18),{ENTRY:RIGHT}),
((19, 19),),
),

( #2
((19, 25),),
((19, 26),),
),

( #X
		((19,  27), ),
((18, 28), ),	((19,  28), ),	((20, 28), ),
		((19,  29), ),
),

( #T
((15, 28), ),	((16,  28), ),	((17, 28), ),
		((16,  29), ),
),

( #3
((16, 30), ),
((16, 31), ),
((16, 32), {ENTRY:DOWN}),
),

( #3
((19, 30), ),
((19, 31), ),
((19, 32), {ENTRY:DOWN}),
),



)

####### Constants
FLAGS = (USE_AMBUSH_COUNTERS,)

MARINES =   (
		(
		"Sakharov", 
		((TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_SERGEANT,MARINETEAM), (TERMINATOR_MARINE_WITH_ASSAULT_CANNON,MARINETEAM)),
		),
                (
		"Sternfeld", 
		((TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_CHAIN_FIST,MARINETEAM), (TERMINATOR_MARINE_SERGEANT_WITH_SWORD,MARINETEAM), (TERMINATOR_MARINE_WITH_HEAVY_FLAMER,MARINETEAM)),
		)
	    )

BLIPS = (1, 2)

BLIP_SET = BLIP_SET_BASIC


####### Functions
def init(sulkgame):
    global download_counter, download_sq, download_piece
    download_counter = 4
    download_piece = None
    for square in sulkgame.squares.sprites():
        if square.objectivenum == 1:
            download_sq = square
            break
    else:
        raise SystemExit
    
    
def maction_end_script(sulkgame):
    return ""


def post_action_script(piece, actiontype):
    global download_piece, download_counter
    if piece is download_piece and actiontype == MOVING:
        download_piece = None
        download_counter = 4
    

def end_script(sulkgame):
    global download_piece, download_counter
    if download_sq.piece\
    and download_sq.piece.sprite.type in\
    (TERMINATOR_MARINE_SERGEANT, TERMINATOR_MARINE_SERGEANT_WITH_SWORD):
        newdownload_piece = download_sq.piece.sprite
        if not download_piece:
            download_piece = newdownload_piece
            msg = "Download begins... "
        elif newdownload_piece is download_piece:
            download_counter -= 1
            msg = "Downloading... "
        return msg + "counter is at %d."%download_counter
    else:
        if download_counter != 4:
            download_counter = 4
            return "Counter reset to 4."


def victory_check(sulkgame):
    #In this mission, no draw is possible
    
    for m in sulkgame.marines.sprites():
        if m.type in (TERMINATOR_MARINE_SERGEANT, TERMINATOR_MARINE_SERGEANT_WITH_SWORD):
            break
    else:
        return sulkgame.stealers
    if download_counter == 0:
        return sulkgame.marines
