# Sulk - missions - debug - MISH_debug_1

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
This module contains constants and functions for a Sulk mission.
"""

from constants.mission_locals import *

####### Strings
NAME = "Suicide Mission with no forces"

NUM = 1

FAMILY = "Debug"

AUTHOR = "Games Workshop"

INFO =	"The Space Marines must set the Launch Control room on fire (self-destruction \
also counts).  The Genestealers must prevent this. If the Flamer Marine runs out of \
ammunition or is killed, then the Space Marines lose."

STORY = "This mission is for debugging purposes only.  not to be included in 'stable'\
releases ;)"


####### Board array
BOARD = (	

( #5
((10, 0), {M:None}),
((10, 1), {M:None}),
((10, 2), {M:None}),
((10, 3), {M:None}),
((10, 4), {M:None})
),
( #3room
						    ((10, 5), {DOOR:UP}),
				((9, 6),),	    ((10, 6),),		    ((11, 6),),
((8, 7), {DOOR:RIGHT}),   ((9, 7),),	    ((10, 7),),		    ((11, 7),),
				((9, 8),),	    ((10, 8),),		    ((11, 8),),
						    ((10, 9), {DOOR:UP})
),
( #4
((4, 7),),		((5, 7),),	    ((6, 7),),		    ((7, 7),) 
),
( #2room
((0, 6),),			((1, 6),),	    ((2, 6),),
((0, 7),),			((1, 7),),	    ((2, 7),),		    ((3, 7), {DOOR:RIGHT}),
((0, 8),),			((1, 8),),	    ((2, 8),),
						    ((1, 9), {DOOR:UP})
),
( #T
				((1, 10),),
((0, 11), {ENTRY:LEFT}),		((1,11),),	    ((2,11,), {ENTRY:RIGHT})
),
( #3
((10,10),),	
((10,11),),	
((10,12),)
),
( #T  
((10,13),),
((10,14),),			((11,14),),
((10,15),)
),
( #corner
((12,14),),		((13,14),),
				((13,15), {DOOR:UP})
),
( #3
((10,16),),	
((10,17),),	
((10,18),)
),
( #3  
((13,16),),	
((13,17),),	
((13,18),)
),
( #X
				((10,19),),	
((9,20),),		((10,20),),	    ((11, 20),),
				((10,21),)
),
( #X
				((13,19),),	
((12,20),),		((13,20),),	    ((14, 20),),
				((13,21),)
),
( #5   
((4, 20),),		((5, 20),),	    ((6, 20),),		((7, 20),),	    ((8, 20),) 
),
( #T
((2,19), {ENTRY:UP}),
((2,20),),			((3,20),),
((2,21), {ENTRY:DOWN})
),
( #3  
((10,22),),	
((10,23),),	
((10,24),)
),
( #3   
((13,22),),	
((13,23),),	
((13,24),)
),
( #T   
				((10,25),),
((9,26), {ENTRY:LEFT}),		((10,26),),	    ((11,26),)
),
( #T  
				((13,25),),
((12,26),),		((13,26),),	    ((14,26), {ENTRY:RIGHT})
),
( #3  
((15, 20),),		((16, 20),),	    ((17, 20),)
),
( #1room (THE OBJECTIVE ROOM)
				((19, 19),),	    ((20, 19),),	    ((21, 19),),
((18,20), {DOOR:RIGHT}),	((19, 20),),	    ((20, 20),{O:1,COMMENT:"Launch Control room"}),	    ((21, 20),),
				((19, 21),),	    ((20, 21),),	    ((21, 21),)
)
)


####### Constants
BEGINPLACE = (14,20) #6 squares left of the objective square

FLAGS = (CAT, USE_AMBUSH_COUNTERS)

MARINES =   (
		(
		"Calvin", 
		( (TERMINATOR_MARINE_WITH_STORM_BOLTER, MARINETEAM), )
		),
	   )

BLIPS = (0, 1)

BLIP_SET = BLIP_SET_BASIC


####### Functions
def victory_check(sulkgame):
    #In this mission, no draw is possible
    
    # Find the objective square and attach it to the team
    if not hasattr(sulkgame.marines, "objsq"):
	for square in sulkgame.squares.sprites():
	    if square.objectivenum is 1:
		sulkgame.marines.objsq = square
		break
	    
    # Check for marine win
    if sulkgame.marines.objsq.get_flaming(): return sulkgame.marines
