# Sulk - missions - MISH_space_hulk_2

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
This module contains constants and functions for a Sulk mission.
"""

from constants.mission_locals import *


####### Strings
NAME = "Exterminate"

NUM = 2

FAMILY = "Space Hulk"

AUTHOR = "Games Workshop"

INFO = "The Space Marines must kill 30 stealers, or be blocking all entry \
areas (by being within 6 squares of them). The \
Stealers must wipe out the Marines before this happens. \
Blips and Stealers may not lurk in this mission."

STORY = "A key junction near the beachhead had to be blocked to prevent Stealer \
reinforcements from disrupting the main force's preparations.  Squad Constantine \
was sent to cause as many casualties as possible, despite being outnumbered by over \
sixty to one."


####### Board array
BOARD = (

( #corner
((0, 19),),		    ((1, 19),),
((0, 20),) 
),
( #3
((2, 19),),	    ((3, 19),),		    ((4, 19),) 
),
( #T
			    ((6, 18),),
((5, 19),),	    ((6, 19),),
		    	    ((6, 20),) 
),
( #2room
((5, 14),{M:None}),	    ((6, 14),{M:None}),	    ((7, 14),{M:None}),
((5, 15),{M:None}),	    ((6, 15),{M:None}),	    ((7, 15),{M:None}),    ((8, 15),{DOOR:RIGHT}),
((5, 16),{M:None}),	    ((6, 16),{M:None}),	    ((7, 16),{M:None}),
			    ((6, 17),{DOOR:UP}) 
),
( #2
((9,15),),	    ((10,15),) 
),
( #3room
						    ((13, 13),{DOOR:UP}),
			    ((12, 14),{M:None}),    ((13, 14),{M:None}),    ((14, 14),{M:None}),
((11, 15),{DOOR:RIGHT}),((12, 15),{M:None}),  ((13, 15),{M:None}),    ((14, 15),{M:None}),    ((15,15),{DOOR:RIGHT}),
			    ((12, 16),{M:None}),    ((13, 16),{M:None}),    ((14, 16),{M:None}) 
),
( #5 
((16, 15),),	    ((17, 15),),	    ((18, 15),),	    ((19, 15),),	    ((20, 15),) 
), 
( #4
((13, 9),),
((13, 10),),
((13, 11),),
((13, 12),) 
),
( #X
			    ((13, 6),),	
((12, 7),{DOOR:RIGHT}),((13, 7),),	    ((14, 7),{DOOR:RIGHT}),
			    ((13, 8),) 
),
( #1room   
((8, 6),{M:None}),	    ((9, 6),{M:None}),	    ((10, 6),{M:None}),
((8, 7),{M:None}),	    ((9, 7),{M:None}),	    ((10, 7),{M:None}),	    ((11, 7),),
((8, 8),{M:None}),	    ((9, 8),{M:None}),	    ((10, 8),{M:None}) ),  
( #2
((13, 4),),
((13, 5),) 
),
( #2room
((12, 0),{M:None}),	    ((13, 0),{M:None}),    ((14, 0),{M:None}),
((12, 1),{M:None}),	    ((13, 1),{M:None}),    ((14, 1),{M:None}),	((15, 1),{DOOR:RIGHT}),
((12, 2),{M:None}),	    ((13, 2),{M:None}),    ((14, 2),{M:None}),
			    ((13, 3),{M:None}) 
),
( #3   
((16, 1),),	    ((17, 1),),		    ((18, 1),) 
),
( #T 
((19, 1),{DOOR:RIGHT}),((20, 1),),	    ((21, 1),),
			    ((20, 2),) 
), 
( #corner
((22, 1),),	    ((23, 1),),
			    ((23, 2),) 
),
( #3
((20, 3),),
((20, 4),),
((20, 5),) 
),
( #T
((23, 3),),
((23, 4),),		    ((24, 4),{DOOR:RIGHT}),
((23, 5),) 
),
( #3
((25, 4),),	    ((26, 4),),		    ((27, 4),) 
),
( #X
			    ((29, 3),),
((28, 4),),	    ((29, 4),),		    ((30, 4),{ENTRY:RIGHT}),
			    ((29, 5,),) 
),
( #T
((29, 0),{ENTRY:UP}), 
((29, 1),),	    ((30, 1),{ENTRY:RIGHT}), 
((29, 2),) 
),
( #3   
((25, 7),),	    ((26, 7),{DOOR:RIGHT}),    ((27, 7),) 
),
( #X
			    ((29, 6),),
((28, 7),),	    ((29, 7),),		    ((30, 7),{ENTRY:RIGHT}),
			    ((29, 8,),{ENTRY:DOWN}) 
),
( #T
			    ((23, 6),),
((22, 7),),	    ((23, 7),),		    ((24, 7),) 
),
( #T		    
			    ((20, 6),{DOOR:UP}),
((19, 7),),	    ((20, 7),),		    ((21, 7),) 
),
( #4
((15, 7),),	    ((16, 7),),		    ((17, 7),),		    ((18, 7),) 
),# --jump to lower half --
( #3room		    
			    ((6, 21),{DOOR:UP}),
((5, 22),{M:None}),	    ((6, 22),{M:None}),	    ((7, 22),{M:None}),
((5, 23),{M:None}),	    ((6, 23),{M:None}),	    ((7, 23),{M:None}),	    ((8,23),{DOOR:RIGHT}),
((5, 24),{M:None}),	    ((6, 24),{M:None}),	    ((7, 24),{M:None}),
			    ((6, 25),{DOOR:UP}) 
),
( #5   
((9, 23),),	    ((10, 23),),	    ((11, 23),),	    ((12, 23),),	((13, 23),) 
),
( #2room
			    ((15, 22),{M:None}),    ((16, 22),{M:None}),	    ((17, 22),{M:None}),
((14, 23),{DOOR:RIGHT}),((15, 23),{M:None}),  ((16, 23),{M:None}),	    ((17, 23),{M:None}),
			    ((15, 24),{M:None}),    ((16, 24),{M:None}),	    ((17, 24),{M:None}),
						    ((16, 25),{DOOR:UP}) 
),
( #corner
((16, 26),),
((16, 27),),		    ((17, 27),) 
),
( #X
			    ((6, 26),),
((5, 27),{DOOR:RIGHT}),((6, 27),),	    ((7, 27),{DOOR:RIGHT}),
			    ((6, 28),) 
),
( #5
((0, 21),),
((0, 22),),
((0, 23),),
((0, 24),),
((0, 25),) 
),
( #corner
((0, 26),),
((0, 27),),		    ((1, 27),) 
),
( #3
((2, 27),),	    ((3, 27),),		    ((4, 27),) 
),
( #corner
((8, 27),),	    ((9, 27),),	    
			    ((9, 28),) 
),
( #4   
((6, 29),),
((6, 30),),
((6, 31),),
((6, 32),) 
),
( #5   
((6, 33),),
((6, 34),),
((6, 35),),
((6, 36),),
((6, 37),) 
),
( #2   
((9, 29),),
((9, 30),) 
),
( #4
((9, 31),),
((9, 32),),
((9, 33),),
((9, 34),) 
),
( #T   
((9, 35),),
((9, 36),),		    ((10, 36),{ENTRY:RIGHT}),
((9, 37),) 
),
( #X		    
			    ((9, 38),),
((8, 39),),	    ((9, 39),),		    ((10, 39),{ENTRY:RIGHT}),
			    ((9, 40),{ENTRY:DOWN}) 
),
( #X		    
			    ((6, 38),),
((5, 39),),	    ((6, 39),),		    ((7, 39),),
			    ((6, 40),{ENTRY:DOWN}) 
),
( #T
((2, 39),{ENTRY:LEFT}),	    ((3, 39),),		    ((4, 39),),
			    ((3, 40),{ENTRY:DOWN}) 
)
)
	
	
####### Constants
BEGINPLACE = (6,23)

FLAGS = ()

#Flamer deployed by marines goes first:
MARINES =   (
		(
		"Constantine", 
		( (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,STEALERTEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_SERGEANT,STEALERTEAM), (TERMINATOR_MARINE_WITH_HEAVY_FLAMER,MARINETEAM) )
		),
	    )

BLIPS = (0, 2) #begin game with 0 blips; 2 reinf per turn

BLIP_SET = BLIP_SET_BASIC


####### Functions
def pre_deploy_rule(aclass, square, squadname=None):    
    # In this mission each marine deploys in a different room.
    # Stealers may not use entrypoints within 6 squares of a marine.
    if aclass.team.type == MARINETEAM:
	for sqr in square.section.sprites():
	    if sqr.piece: 
                return False
	else: return True
    elif square.get_team_is_near(aclass.team.enemy_team): 
	#(stealer case)
	return False
    else: return True
    

def maction_end_script(sulkgame):
    # Return a message of encouragement for the marines
    if sulkgame.stealers.casualties == 1:
	return "The %s have 1 kill so far." % sulkgame.marines.type
    elif sulkgame.stealers.casualties == 0:
	return "The %s have no kills so far." % sulkgame.marines.type
    else:
	return "The %s have %d kills so far." % (sulkgame.marines.type, sulkgame.stealers.casualties)


def end_script(sulkgame):
    # In this mission no lurking is permitted.
    # We kill the lurking stealer sprites.
    i = 0
    for piece in sulkgame.stealers.sprites():
	if piece.get_lurking(): 
	    i += 1 
	    piece.kill(NODEATH)
    if i == 1: return "A Stealer piece is lost."
    elif i: return "%d Stealer pieces lost."%i
    else: return ""


def victory_check(sulkgame):
    # Draw not possible here.
    
    marines = sulkgame.marines
    # Check for marine win by killing stuff
    if sulkgame.stealers.casualties >= 30: return marines
    # Check for marine win by blocking off entrypoints
    for square in sulkgame.squares.sprites():
        if square.isentry and not square.get_team_is_near(marines): break
    else: return marines
    
    # Check for stealer win by killing all marines
    if not marines: return sulkgame.stealers
