# Sulk - missions - MISH_space_hulk_3

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
This module contains constants and functions for a Sulk mission.
"""

from constants.mission_locals import *

####### Strings
NAME = "Rescue"

NUM = 3

FAMILY = "Space Hulk"

AUTHOR = "Games Workshop"

INFO = "A Space Marine must exit the map with the C.A.T.. \
The Stealers must prevent this by destroying the C.A.T.. \
If the C.A.T. leaves the map but is damaged, the game is a draw."

STORY = "A Cyber-Altered Task Unit had infiltrated the Hulk and \
taken layout and security data from its command systems. \
Squad Ilyich retrieved it but became cut off from their \
company.  Squad Abel was sent to reinforce them and assist \
in returning the C.A.T. to the dropship."

####### Board array
#
# laid out in 3 parts
#     
#	center  -  right
#     /
#   left
#
BOARD = (

## Right part

( #2
((19, 0),{ENTRY:UP}),
((19, 1),)
),
( #X
			((19, 2),),
((18, 3),{ENTRY:LEFT}), ((19, 3),),	    ((20, 3),{ENTRY:RIGHT}), 
			((19, 4),)
),
( #3
((19, 5),),
((19, 6),),
((19, 7),)
),
( #T
((19, 8),),
((19, 9),),		((20, 9),),
((19, 10),)
),
( #3
((21, 9),),	((22, 9),),	((23, 9),)
),
( #T
((24, 9),),	((25, 9),),	((26, 9),),
			((25,10),)
),
( #5 plus marines
((27, 9),{M:"Ilyich"}),((28, 9),{M:"Ilyich"}),	((29, 9),{M:"Ilyich"}),	((30, 9),{M:"Ilyich"}),	((31, 9),{M:"Ilyich"})
),
( #3room
		    ((25,11),{DOOR:UP}),
((24, 12),),	    ((25,12),),	    ((26, 12),),
((24, 13),),	    ((25,13),),	    ((26, 13),),	 ((27,13),{DOOR:RIGHT}),
((24, 14),),	    ((25,14),),	    ((26, 14),),
		    ((25, 15),{DOOR:UP}) 
),
( #5 plus marines
((28,13),{M:"Ilyich"}),((29,13),{M:"Ilyich"}),	((30,13),{M:"Ilyich"}),	((31,13),{M:"Ilyich"}),	((32,13),{M:"Ilyich"})
),
( #3room
						    ((19,11),{DOOR:UP}),
				((18, 12),),	    ((19,12),),	    ((20, 12),),
((17,13),{DOOR:RIGHT}),	((18, 13),),	    ((19,13),),	    ((20, 13),),
				((18, 14),),	    ((19,14),),	    ((20, 14),),
						    ((19,15),{DOOR:UP}) 
),
( #corner
((19,16),),
((19,17),),	    ((20,17),)
),
( #3
((21,17),),((22,17),),	    ((23,17),)
),
( #T
		    ((25,16),),
((24,17),),((25,17),),	    ((26,17),)
),
( #T
((27,17),),((28,17),),	    ((29,17),),
		    ((28,18),)
),
( #4
((28,19),),
((28,20),),
((28,21),),
((28,22),{ENTRY:DOWN}) 
),
( #3
((30,17),),((31,17),),	    ((32,17),{ENTRY:RIGHT})
),

## Center part

( #T
		    ((15,12),),
((14,13),),((15,13),),	    ((16,13),)
),
( #T
((12,12),),
((12,13),),	    ((13,13),{DOOR:RIGHT}),
((12,14),)
),
( #corner
		    ((12,15),),
((11,16),),((12,16),)
),
( #3
((12, 9),),
((12,10),{DOOR:UP}),
((12,11),)
),
( #3
((15, 9),),
((15,10),{DOOR:UP}),
((15,11),)
),
( #corner
((14, 7),),	((15, 7),),
			((15, 8),)
),
( #X
			((12, 6),{DOOR:UP}),
((11, 7),),	((12, 7),),		((13, 7),),
			((12, 8),{DOOR:UP})
),
( #2
((12, 4),{ENTRY:UP}),
((12, 5),)
),
( #2
((9, 7),{ENTRY:LEFT}),	((10, 7),)
),

## Left part

( #2room
((7, 15),),	    ((8,15),),	    ((9, 15),),
((7, 16),),	    ((8,16),),	    ((9, 16),),	 ((10,16),{DOOR:RIGHT}),
((7, 17),),	    ((8,17),),	    ((9, 17),),
		    ((8,18),{DOOR:UP}) 
),
( #T
((8,19),),
((8,20),),	    ((9,20),),
((8,21),) 
),
( #corner
((10, 20),),((11,20),),
		    ((11,21),)
),
( #X
		    ((8,22),),
((7,23),),((8,23),),	    ((9,23),),
		    ((8,24),)
),
( #T
			((11,22),),
((10, 23),{DOOR:RIGHT}),		    ((11,23),),
			((11,24),)
),
( #4
((3,23),),	((4,23),),	    ((5,23),),	((6,23),)
),
( #X
			((1,22),{ENTRY:UP}),
((0,23),{ENTRY:LEFT}),	((1,23),),	    ((2,23),),
			((1,24),{ENTRY:DOWN})
),
( #5 plus marines and exit
((8,25),{M:"Abel"}),
((8,26),{M:"Abel"}),
((8,27),{M:"Abel"}),
((8,28),{M:"Abel"}),
((8,29),{M:"Abel",EXIT:DOWN})
),
( #5 plus marines and exit
((11,25),{M:"Abel"}),
((11,26),{M:"Abel"}),
((11,27),{M:"Abel"}),
((11,28),{M:"Abel"}),
((11,29),{M:"Abel",EXIT:DOWN})
)

)
	
	
####### Constants
BEGINPLACE = (8,24)

FLAGS = (CAT,)

MARINES =   (
		(
		"Abel",
		    (   
			(TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), 
			(TERMINATOR_MARINE_SERGEANT,MARINETEAM), (TERMINATOR_MARINE_WITH_HEAVY_FLAMER,MARINETEAM) 
		    )
		),
		(
		"Ilyich", #with the C_A_T deployed in possession of one of the marines
		    (   
			(CAT,MARINETEAM,WITHSQUAD), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM),
			(TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_SERGEANT,MARINETEAM), (TERMINATOR_MARINE_WITH_HEAVY_FLAMER,MARINETEAM)
		    )
		)
	    )

BLIPS = (0, 3)

BLIP_SET = BLIP_SET_BASIC


####### Functions
def pre_deploy_rule(aclass, square, squadname=None):    
    # 2 squads in 2 corridors each
    if aclass.team.type == MARINETEAM and square.deploy_attribute != squadname: return False
    else: return True


def victory_check(sulkgame):
    # Find the C.A.T. if possible and attach it to the SulkGame instance
    if not hasattr(sulkgame, '_thecat'):
	sulkgame._thecat = None
	for s in sulkgame.squares.sprites() + sulkgame.limbosquares.sprites():
	    for f in s.features.sprites():
		if getattr(f, 'type', None) == CAT:
		    sulkgame._thecat = f
		    break
	    if sulkgame._thecat is not None: break
	else:
	    for m in sulkgame.marines.sprites():
		for thing in m.possessions.sprites():
		    if getattr(thing, 'type', None) == CAT:
			sulkgame._thecat = thing
			break
		if sulkgame._thecat is not None: break
	    else:
		# There is no cat 
		# (There is no spoon!)
		return sulkgame.stealers
	    
    print >> DEBUG_STREAM, ">>>>>>>>>>>>>>>>",sulkgame._thecat
    # See if the cat is destroyed, or the marines are all dead
    if not sulkgame._thecat.alive() or not sulkgame.marines: 
	return sulkgame.stealers
    # Find marine with cat on a limbosquare
    for m in sulkgame.marines.sprites():
	if m.get_lurking() and sulkgame._thecat in m.possessions.sprites():
	    break
    else: 
	# The cat is still onboard
	return
    # The cat has escaped
    if sulkgame._thecat.damaged: 
	# Draw
	return NEITHER
    else: 
	# Marine win
	return sulkgame.marines
