# Sulk - missions - MISH_space_hulk_5

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
This module contains constants and functions for a Sulk mission.
"""

from constants.mission_locals import *

####### Strings
NAME = "Decoy"

NUM = 5

FAMILY = "Space Hulk"

AUTHOR = "Games Workshop"

INFO = "To win, the Space Marines must get 5 \
Marines off the map.  The Stealers must prevent this."

STORY = "Four squads were committed to attack the main cryogenics \
control room.  The area was heavily occupied.  To buy time for this \
attack, squads Abraham and Harken conducted a decoy \
action."

####### Board array

# Three parts:
#               top
#		| |
#	left - middle

BOARD = (

## Top part
( #T
((15, 0),{ENTRY:LEFT}),		((16, 0),),	    ((17, 0),{ENTRY:RIGHT}),
				((16, 1),),
),
( #4
((16, 2),),
((16, 3),),
((16, 4),),
((16, 5),)
),
( #3
((16, 6),),
((16, 7),{DOOR:UP}),
((16, 8),),
),
( #X
                                ((16, 9),),
((15,10), ),          ((16,10),),          ((17,10),),
				((16,11),)
),
( #5 plus marines
((10,10),{M:"Abraham"}),((11,10),{M:"Abraham"}), ((12,10),{M:"Abraham"}),    ((13,10),{M:"Abraham"}),    ((14,10),{M:"Abraham"}) 
),
( #2
((18,10),),		((19,10),)
),
( #T
((20,10),),		((21,10),),	    ((22,10),),
				((21,11),)
),
( #4
((23,10),),		((24,10),),	    ((25,10),),    ((26,10),)
),
( #corner
				((28, 9),{ENTRY:UP}),
((27,10),),		((28,10),)
),
( #T
((16,12),),
((16,13),),			((17,13),{DOOR:RIGHT}),
((16,14),)
),
( #2
((18,13),),		((19,13),)
),
( #X
				((21,12),{DOOR:UP}),
((20,13),),		((21,13),),	    ((22,13),),
				((21,14),{DOOR:UP})
),
( #5 plus marines
((23,13),{M:"Harken"}),((24,13),{M:"Harken"}),((25,13),{M:"Harken"}),((26,13),{M:"Harken"}),((27,13),{M:"Harken"}) 
),

## Connecting pieces
( #5
((16,15),),
((16,16),),
((16,17),),
((16,18),),
((16,19),)
),
( #5
((21,15),),
((21,16),),
((21,17),),
((21,18),),
((21,19),)
),

## Middle part
( #3room
						((16,20),{DOOR:UP}),
		((15,21),),                     ((16,21),),         ((17,21),),
((14,22), {DOOR:RIGHT}),((15,22),),       ((16,22),),	    ((17,22),),              ((18,22), {DOOR:RIGHT}),
		((15,23),),                     ((16,23),),	    ((17,23),),
),
( #3room
						((21,20),{DOOR:UP}),
		((20,21),),                     ((21,21),),         ((22,21),),
((19,22), {DOOR:RIGHT}),((20,22),),       ((21,22),),	    ((22,22),),              ((23,22), {DOOR:RIGHT}),
		((20,23),),                     ((21,23),),	    ((22,23),),
),
( #3
((24,22),),		((25,22),{DOOR:RIGHT}),	((26,22),)
),
( #T
				((28,21),{DOOR:UP}),
((27,22),),		((28,22),),	((29,22),)
),
( #corner
				((31,21),),
((30,22),),		((31,22),)
),
( #corner
((28,19),),			((29,19),),
((28,20),)
),
( #X
				((31,18),{ENTRY:UP}),
((30,19),),		((31,19),),	((32,19),{ENTRY:RIGHT}),
				((31,20),)
),

## Connecting piece
( #4
((10,22),),		((11,22),),	((12,22),),	((13,22),)
),

## Left part
( #T
(( 7,22),),		(( 8,22),),	(( 9,22),),
				(( 8,23),)
),
( #4
(( 3,22),),		(( 4,22),),	(( 5,22),),	(( 6,22),)
),
( #X
				(( 1,21),),
(( 0,22),{ENTRY:LEFT}),		(( 1,22),),	(( 2,22),{DOOR:RIGHT}),
				(( 1,23),)
),
( #2
(( 1,19),),	
(( 1,20),)
),
( #2room
(( 0,15),),			(( 1,15),),	    (( 2,15),),
(( 0,16),),			(( 1,16),),	    (( 2,16),),	(( 3,16), {DOOR:RIGHT}),
(( 0,17),),			(( 1,17),),	    (( 2,17),),
				(( 1,18),{DOOR:UP}),
),
( #3
(( 4, 16), ),		(( 5,16),),	    (( 6,16), {ENTRY:RIGHT})
),
( #2
(( 1, 24),),
(( 1, 25),)
),
( #2room
				(( 1,26),{DOOR:UP}),
(( 0,27),),			(( 1,27),),	    (( 2,27),),
(( 0,28),),			(( 1,28),),	    (( 2,28),),	(( 3,28), {DOOR:RIGHT}),
(( 0,29),),			(( 1,29),),	    (( 2,29),),
),
( #3
(( 4,28), ),		(( 5,28),),	    (( 6,28),)
),
( #3
(( 8,24),),
(( 8,25),),
(( 8,26),)
),
( #T
				(( 8,27),),
(( 7,28),),		(( 8,28),),	    (( 9,28),{EXIT:RIGHT})
),

)	
	
####### Constants
BEGINPLACE = ( 8,22)

FLAGS = ()

MARINES =   (
		(
		"Abraham", 
		    ( (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_SERGEANT,MARINETEAM), (TERMINATOR_MARINE_WITH_HEAVY_FLAMER,MARINETEAM) )
		),
		(
		"Harken",
		    ( (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_WITH_STORM_BOLTER,MARINETEAM), (TERMINATOR_MARINE_SERGEANT,MARINETEAM), (TERMINATOR_MARINE_WITH_HEAVY_FLAMER,MARINETEAM) )
		)
	    )

BLIPS = (3, 2) #begin game with 3 blips; 2 reinf per turn

BLIP_SET = BLIP_SET_BASIC


####### Functions
def _get_numlurking(sulkgame):
    """_get_numlurking(sulkgame) -> int
    
     Find number of lurking marines"""
    #mission unique
    return len([1 for m in sulkgame.marines.sprites() if m.get_lurking()])


def pre_deploy_rule(aclass, square, squadname=None):    
    if getattr(aclass.team, 'type', None) == MARINETEAM and square.deploy_attribute != squadname: 
        return False
    return True
    

def end_script(sulkgame):
    # Find number of lurking marines
    numlurking = _get_numlurking(sulkgame)
    if numlurking == 0:
	return "No Marines have escaped so far."
    elif numlurking == 1:
	return "One Marine has escaped so far."
    else:
	return "%d Marines have escaped so far."%numlurking


def victory_check(sulkgame):
    # N.B. In this mission, no draw is possible

    # Check for marine win - 5 marines lurking
    if _get_numlurking(sulkgame) >= 5: return sulkgame.marines
    # Check for stealer win - fewer than 5 marines
    elif len(sulkgame.marines) < 5: return sulkgame.stealers

