# Sulk - constants - colors

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
Colors and alpha levels for Sulk.
"""

####### Colo(u)rs - RGB

## Basics
BLACK, GREY0, GREY1, GREY2, WHITE = \
(0, 0, 0), (70, 70, 70), (100, 100, 100), (180, 180, 180), (250, 250, 250)
RED, YELLOW	= (250, 50, 50), (250, 233, 30)
LIGHTYELLOW	= 250, 250, 150 #hmm
SKYBLUE		= (70, 150, 250)
MIDBLUE		= (120, 120, 250)
NAVYBLUE	= (20, 20, 150)
DARKPURPLE	= (60, 20, 60) #70, 30, 70 -- hmm
MAGENTA		= (255, 0, 255)
## Screen boxes
RECT_COLOR	= RED #GREY1 -- hmm
BG_COLOR	= DARKPURPLE
MAP_BG_COLOR	= BLACK
## Teams
MARINE_COLOR, STEALER_COLOR, NEITHER_COLOR = (200, 50, 50), (50, 200, 50), (150, 200, 210)
## TurnClock
TURNTIMER_TEXT_COLOR = WHITE
## AmmoClock
AMMOCLOCK_BACK_COLOR = GREY1
## DeployClock
DEPLOYCLOCK_BACK_COLOR = GREY1
## CPClock
CPCLOCK_TEXT_COLOR_NORMAL = WHITE
CPCLOCK_TEXT_COLOR_REVEALED = YELLOW
CPCLOCK_BACK_COLOR_NORMAL = CPCLOCK_BACK_COLOR_REVEALED = GREY1
## APClock
APCLOCK_BACK_COLOR = GREY1
## DisplayDie
DISPLAYDIE_BACK_COLOR = GREY1
## HiLite
HILITE_GREEN_COLOR = 158, 255, 181
HILITE_RED_BORDER_COLOR = 255, 60, 60
HILITE_RED_COLOR = 255, 157, 157
## LittleMapBox
LITTLEMAPBOX_BOX_COLOR = WHITE
## Dialog
DIALOG_TEXT_COLOR = YELLOW
DIALOG_EDGE_COLOR = WHITE
DIALOG_BACK_COLOR = GREY1
## ClickBox
CLICKBOX_TEXT_COLOR = WHITE
CLICKBOX_EDGE_COLOR = WHITE
CLICKBOX_BACK_COLOR = BLACK
## ScrollMessage
SCROLLMESSAGE_TEXT_COLOR = WHITE
## SquareComment
COMMENT_TEXT_COLOR = NAVYBLUE
COMMENT_BACK_COLOR = GREY2
COMMENT_EDGE_COLOR = DARKPURPLE
## ToolTip
TOOLTIP_TEXT_COLOR = BLACK
TOOLTIP_BACK_COLOR = GREY2
TOOLTIP_EDGE_COLOR = WHITE


####### Alpha - levels for HUD elements etc

DIALOG_ALPHA = 220
CLOCKS_ALPHA = 190
HILITE_ALPHA = 140
COMMENT_ALPHA = 190
TOOLTIP_ALPHA = 205
