# Sulk - constants - mission_locals

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
Constants required by Sulk mission files.
"""

###### Import
from layout import DEBUG_STREAM
from rules import\
M, ENTRY, EXIT, O, COMMENT,\
UP, DOWN, LEFT, RIGHT,\
WITHSQUAD, ONBOARD,\
SKEWERED, FLAMBEED, NODEATH, SHOT,\
BLIP_SET_BASIC,\
ACTING, USE_AMBUSH_COUNTERS, MOVING, USING, CCING, OVERWATCHING, TURNING, SHOOTING
from strings import\
MARINETEAM, STEALERTEAM, NEITHER, BOTH,\
CAT,\
GENESTEALER,\
BLIP,\
AMBUSH_COUNTER,\
TERMINATOR_MARINE,\
TERMINATOR_MARINE_WITH_STORM_BOLTER,\
TERMINATOR_MARINE_WITH_HEAVY_FLAMER,\
TERMINATOR_MARINE_WITH_CHAIN_FIST,\
TERMINATOR_MARINE_WITH_ASSAULT_CANNON,\
TERMINATOR_MARINE_WITH_LIGHTNING_CLAWS,\
TERMINATOR_MARINE_WITH_THUNDER_HAMMER,\
TERMINATOR_MARINE_SERGEANT,\
TERMINATOR_MARINE_SERGEANT_WITH_SWORD,\
TERMINATOR_MARINE_CAPTAIN,\
TERMINATOR_MARINE_LIBRARIAN,\
DUCTING, BULKHEAD, DOOR, CRYOGENIC_TANK, FLAMES, RUBBLE, CRATE

## Mission skeleton follows

####### Strings
NAME = "GENERIC NAME"

NUM = 0

FAMILY = "FAMILY NAME"

AUTHOR = "AUTHOR"

INFO =	"INFO"

STORY = "STORY"


####### Board array
BOARD = ()	


####### Constants
BEGINPLACE = (0, 0) #origin

FLAGS = ()

MARINES = ()

BLIPS = (0, 0)

BLIP_SET = BLIP_SET_BASIC


####### Functions

# These return the best default values, i.e. do nothing.
# You should at least override victory_check().

def init(sulkgame):
    return


def pre_deploy_rule(aclass, square, squadname=None):
    return True


def post_deploy_script(piece):
    return
    

def post_action_script(piece, actiontype):
    return

    
def maction_end_script(sulkgame):
    return ""


def end_script(sulkgame):
    return ""


def victory_check(sulkgame):
    # no winner
    return


def finish(sulkgame):
    return
