# Sulk - constants - strings

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""
Important strings.
"""

##############################################################################
####### Import

from os.path import join as pathjoin


##############################################################################
####### Strings

# Application

APP_STRING	        = "Sulk"
VERSION_STRING	        = "0.29-snapshot"
APP_AND_VERSION_STRING  = "%s version %s" % (APP_STRING, VERSION_STRING)
COPYRIGHT_STRING        = "Copyright 2002-03 Toby Woodwark <zirtix@softhome.net>.  \
This program is free software; see COPYING for details."
MISSIONS_GLOB_STRING    = "MISH*.py"

# Paths

DEFAULT_SOUND_DIRECTORY	    = pathjoin('data', 'sounds')
DEFAULT_IMAGE_DIRECTORY	    = pathjoin('data', 'images')
DEFAULT_THEME_DIRECTORY	    = pathjoin('data', 'themes', 'default')
DEFAULT_MISSIONS_DIRECTORY  = pathjoin('data', 'missions')
DEFAULT_FONT_DIRECTORY	    = pathjoin('data', 'fonts')

#Players

LOCAL_PLAYER            = "local"
AI_PLAYER               = "ai"
REMOTE_PLAYER           = "remote"

# Piece types

CAT = "C.A.T. unit"
GENESTEALER     = "Genestealer"
BLIP            = "Blip"
AMBUSH_COUNTER  = "Ambush Counter"
TERMINATOR_MARINE                       = "Terminator Marine (BASE CLASS)"
TERMINATOR_MARINE_WITH_STORM_BOLTER     = "Terminator Marine"
TERMINATOR_MARINE_WITH_HEAVY_FLAMER     = "Terminator Flamer Marine"
TERMINATOR_MARINE_WITH_CHAIN_FIST       = "Terminator Marine with Chain Fist"
TERMINATOR_MARINE_WITH_ASSAULT_CANNON   = "Terminator Marine with Assault Cannon"
TERMINATOR_MARINE_WITH_LIGHTNING_CLAWS  = "Terminator Marine with Lightning Claws"
TERMINATOR_MARINE_WITH_THUNDER_HAMMER   = "Terminator Marine with Thunder Hammer and Storm Shield"
TERMINATOR_MARINE_SERGEANT              = "Terminator Sergeant"
TERMINATOR_MARINE_SERGEANT_WITH_SWORD   = "Terminator Sergeant with Power Sword"
TERMINATOR_MARINE_CAPTAIN               = "Terminator Captain"
TERMINATOR_MARINE_LIBRARIAN             = "Terminator Librarian"

# Piece status

INACTIVE    = "inactive"
ACTIVE      = "active"
USED        = "used"

# Features

DUCTING     = "some ducting"
DOOR        = "a door"
FLAMES      = "some flames"
CRYOGENIC_TANK = "a cryogenic storage tank"
BULKHEAD    = "a bulkhead"
RUBBLE      = "some rubble"
CRATE       = "a crate"

# Teams

STEALERTEAM = "Genestealers"
MARINETEAM  = "Space Marines"
NEITHER = BOTH = ""
