# Sulk - players - ai0 - phases

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#*****************************************************************************

"""
AI0 rules objects.

We only cover stealers for the moment.
"""

##############################################################################
####### Import / set up

## Modules
import pygame, random
import pprint #debug

## Sulk modules
from constants import *
import util
import sprites
import missions
from players.local.phases import *
import UIinput

##############################################################################
####### Game Phase (UI handlers level 2)

class Phase(Phase):
    #overriding sneakily to stop buttons being built and so on

    _secrets_team_type = None #Never makes much difference anyway
    
    class _SelectGroup(Phase._SelectGroup): #??
	# no build_buttons
        #TODO replace with AI thinking messages in button box (optional)
        
        def add_internal(self, sprite):
            
            assert isinstance(sprite, sprites.Piece)
            if self.sprite is not 0:
                self.sprite.remove_internal(self)
            self.sprite = sprite
            sprite.build_visuals()
            
            
class Stealer_Deploy_Phase(Stealer_Deploy_Phase):

    _secrets_team_type = None


class Stealer_Reinforce_Phase(Stealer_Reinforce_Phase):

    _secrets_team_type = None


class Stealer_Action_Phase(Phase):
    """While the button is not pressed, stealer player uses pieces.
    """

    interruptable = True #?
    name = "Stealer Action Phase"
    
    def __init__(self, sulkgame, ambush_counter):
	
	Phase.__init__(self, sulkgame)
        self.ambush_counter = ambush_counter
	self.game.stealers.status = ACTIVE
	self.game.donebutton.status = DISABLED
	self.unselect()#?


    def loop(self):
	
	for s in self.game.stealers.sprites():
	    if s.status != USED: break#?
	else:
	    self._end()
	    return

	if self.handlers: 
	    self.handlers[-1].handle()
	
        elif self.cpiece().alive():
	    print >> DEBUG_STREAM, "players.ai0.phases.Stealer_Action_Phase --> loop, no handlers, cpiece exists" #DEBUG
	    self.game.stealers.player.UIinput.Use_A_Piece(self, self.cpiece())
	
	else:
	    # Ensure that we keep selecting pieces
	    self.game.stealers.player.UIinput.Select_A_Piece(self, self.game.stealers)


    def _end(self):
	
	sprites.ScrollMessage('Stealer AI done moving.')
	self.game.stealers.status = INACTIVE
	self.unselect()
        if self.ambush_counter:
            print >> DEBUG_STREAM, "Stealer_Action_Phase --> _end, ambush counter" #DEBUG
            sprites.ScrollMessage("Stealer AI deploys an Ambush Counter.")
            # Custom cruft copying here - TW
            list = []
            value = self.game.get_ambush_counter_val()
            for sqr in self.game.squares.sprites():
                # can't deploy ambush counters near a marine
                if not sqr.piece and sqr.get_passable() and\
                self.game.mission.pre_deploy_rule(sprites.Ambush_Counter, sqr) and\
                not sqr.get_team_is_near(sprites.Ambush_Counter.team.enemy_team):
                    for marine in sprites.Ambush_Counter.team.enemy_team.sprites():
                        # can't deploy a counter in marine LOS
                        if marine.can_see(sqr):
                            break
                    else: 
                        list.append(sqr)
            # Deploy randomly
            choice = random.choice(list)
            sprites.Ambush_Counter(choice, value)
	self.game.donebutton.status = DISABLED
	Phase._end(self)
	End_Phase(self.game)


class Marine_Action_Phase(Phase):
    
    def __init__(self, sulkgame, timer_bonus, cp_bonus):
	
	raise SystemExit, "players.ai0.phases.Marine_Action_Phase -- AI0 can't handle Marines yet!"


class Postgame_Phase(Phase):
    
    def __init__(self, sulkgame, victorystring):

	raise SystemExit, "players.ai0.phases.Marine_Action_Phase -- AI0 not suitable"
