# Sulk - sound

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#******************************************************************************

"""Sound functions."""

##############################################################################
####### Import

import pygame
import util
import sprites
from constants import *

# We also require 'all_sounds' global, a sequence of all game sounds
# And 'test_sound', a Sound object

all_sounds = []
test_sound = util.Null

##############################################################################
####### Functions

def stop():
    """sound.stop() -> None
    prevent sounds playing
    
    Also records this in options."""
    
    pygame.mixer.quit()
    options.SOUND_ENABLED = False


def start():
    """sound.start() -> None
    allow sounds to play
    
    Also records this in options."""

    try:
	pygame.mixer.init()
    except:
	sprites.ScrollMessage("Sorry, could not enable sound.")#?
	print >> DEBUG_STREAM, "sound.start, Could not initialize sound" #DEBUG
    else:
	options.SOUND_ENABLED = True


def set_vol(xpercent):
    """sound.set_vol(xpercent) -> None
    set global volume
    
    Expects an int from 0 to 100."""

    assert 0 <= xpercent <= 100
    
    options.SOUND_VOL_PERCENT = xpercent
    x = float(xpercent)/100
    for snd in all_sounds:
	snd.set_volume(x)


def get_vol():
    """sound.set_vol(xpercent) -> int
    get global volume"""

    return options.SOUND_VOL_PERCENT


def test():
    """sound.test() -> None
    play a sample sound"""

    test_sound.play()
