# Sulk - util - draw

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#*****************************************************************************

"""
Sulk drawing functions.
"""

##############################################################################
####### Import

import pygame

from constants import *


##############################################################################
####### Functions 

def borderize(surf, pad, padcolor, bordercolor):
    """util.draw.borderize(surf, pad, padcolor, bordercolor) -> Surface
    
    Give a surface a padding of 'pad' pixels, including a 1-pixel border"""

    srect = surf.get_rect()
    newsurf = pygame.Surface(srect.inflate(pad, pad).size, surf.get_flags(), surf) #inherit surf flags
    newsurf.fill(padcolor)
    newrect = newsurf.get_rect()
    pygame.draw.rect(newsurf, bordercolor, newrect, 1)
    srect.center = newrect.center
    newsurf.blit(surf, srect)
    
    return newsurf

