# Sulk - util - null

#*****************************************************************************
#
#                                   Sulk
#
#       Copyright (c) 2002 Toby Woodwark <zirtix@softhome.net>
#
# This program is free software.  See the file COPYING for details.
#
#*****************************************************************************

"""
Null objects.
"""

##############################################################################
####### Import

import pygame


##############################################################################
####### Objects

zerosurface = pygame.Surface((0,0))

zerorect = zerosurface.get_rect()


class Null:
    """Does nothing, ever.
    
    Compares and hashes equivalent to None, _for great justice_.
    
    This Null implementation is _boss_.  It's the daddy."""
    
    def __init__(self, *args, **kwargs): pass
    def __repr__(self): return "Null"
    __str__ = __repr__
    def __nonzero__(self): return 0
    def __hash__(self): return hash(None)
    def __call__(self, *args, **kwargs): return self
    __getattr__ = __setattr__ = __delattr__ = __call__
    def __eq__(self, other): return (self is other or other is None)
    def __ne__(self, other): return not self.__eq__(other)
    def next(self): raise StopIteration #I believe this preferable
    

Null = Null() # cute, prevents reinstantiation
